=== modified file 'DBUS-API'
--- DBUS-API	2011-11-26 23:08:17 +0000
+++ DBUS-API	2011-11-24 19:09:29 +0000
@@ -112,7 +112,7 @@
       Disable().
    
    f) The date and time this client will be disabled, as an RFC 3339
-      string, or an empty string if this is not scheduled.
+      string, or an empty string if this has not happened.
    
    g) The date and time of the last approval request, as an RFC 3339
       string, or an empty string if this has not happened.

=== modified file 'Makefile'
--- Makefile	2011-11-26 22:22:20 +0000
+++ Makefile	2011-11-26 20:59:56 +0000
@@ -26,16 +26,12 @@
 version=1.4.1
 SED=sed
 
-USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
-GROUP=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nobody || echo 65534)))
-
 ## Use these settings for a traditional /usr/local install
 # PREFIX=$(DESTDIR)/usr/local
 # CONFDIR=$(DESTDIR)/etc/mandos
 # KEYDIR=$(DESTDIR)/etc/mandos/keys
 # MANDIR=$(PREFIX)/man
 # INITRAMFSTOOLS=$(DESTDIR)/etc/initramfs-tools
-# STATEDIR=$(DESTDIR)/var/lib/mandos
 ##
 
 ## These settings are for a package-type install
@@ -44,7 +40,6 @@
 KEYDIR=$(DESTDIR)/etc/keys/mandos
 MANDIR=$(PREFIX)/share/man
 INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
-STATEDIR=$(DESTDIR)/var/lib/mandos
 ##
 
 GNUTLS_CFLAGS=$(shell pkg-config --cflags-only-I gnutls)
@@ -235,7 +230,7 @@
 distclean: clean
 mostlyclean: clean
 maintainer-clean: clean
-	-rm --force --recursive keydir confdir statedir
+	-rm --force --recursive keydir confdir
 
 check:	all
 	./mandos --check
@@ -265,8 +260,8 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
-	./mandos --debug --no-dbus --configdir=confdir \
-		--statedir=statedir $(SERVERARGS)
+	./mandos --debug --no-dbus --configdir=confdir --no-restore \
+	$(SERVERARGS)
 
 # Used by run-server
 confdir/mandos.conf: mandos.conf
@@ -277,8 +272,6 @@
 	install --mode=u=rw $< $@
 # Add a client password
 	./mandos-keygen --dir keydir --password >> $@
-statedir:
-	install --directory statedir
 
 install: install-server install-client-nokey
 
@@ -289,8 +282,6 @@
 
 install-server: doc
 	install --directory $(CONFDIR)
-	install --directory --mode=u=rwx --owner=$(USER) \
-		--group=$(GROUP) $(STATEDIR)
 	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-ctl

=== modified file 'TODO'
--- TODO	2011-11-29 19:25:06 +0000
+++ TODO	2011-11-09 17:16:03 +0000
@@ -41,8 +41,9 @@
 
 * mandos (server)
 ** TODO [#B] Log level							  :BUGS:
-** TODO [#A] Save state to new file and move instead of overwrite
   
+*** TODO /etc/mandos/clients.d/*.conf
+    Watch this directory and add/remove/update clients?
 ** TODO [#C] config for TXT record
 ** TODO Log level option
    syslogger.setLevel(logging.WARNING)

=== modified file 'clients.conf'
--- clients.conf	2011-11-26 23:08:17 +0000
+++ clients.conf	2011-09-19 09:42:55 +0000
@@ -30,9 +30,6 @@
 # How long one approval will last.
 ;approval_duration = 1s
 
-# Whether this client is enabled by default
-;enabled = True
-
 
 ;####
 ;# Example client

=== modified file 'debian/mandos.dirs'
--- debian/mandos.dirs	2011-11-26 22:22:20 +0000
+++ debian/mandos.dirs	2010-09-15 17:33:14 +0000
@@ -4,4 +4,3 @@
 etc/default
 etc/dbus-1/system.d
 usr/sbin
-var/lib/mandos

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2011-11-26 22:22:20 +0000
+++ debian/mandos.postinst	2011-10-10 20:29:58 +0000
@@ -35,12 +35,11 @@
 		--disabled-password --gecos "Mandos password system" \
 		_mandos
 	fi
-	chown _mandos:_mandos /var/lib/mandos
 	;;
-    
+
     abort-upgrade|abort-deconfigure|abort-remove)
 	;;
-    
+
     *)
 	echo "$0 called with unknown argument '$1'" 1>&2
 	exit 1

=== modified file 'mandos'
--- mandos	2011-11-29 19:25:06 +0000
+++ mandos	2011-11-26 20:59:56 +0000
@@ -87,7 +87,7 @@
 
 
 version = "1.4.1"
-stored_state_file = "clients.pickle"
+stored_state_path = "/var/lib/mandos/clients.pickle"
 
 logger = logging.getLogger()
 syslogger = (logging.handlers.SysLogHandler
@@ -128,12 +128,11 @@
     logger.setLevel(level)
 
 
-class PGPError(Exception):
-    """Exception if encryption/decryption fails"""
+class CryptoError(Exception):
     pass
 
 
-class PGPEngine(object):
+class Crypto(object):
     """A simple class for OpenPGP symmetric encryption & decryption"""
     def __init__(self):
         self.gnupg = GnuPGInterface.GnuPG()
@@ -185,7 +184,7 @@
                     ciphertext = f.read()
                 proc.wait()
             except IOError as e:
-                raise PGPError(e)
+                raise CryptoError(e)
         self.gnupg.passphrase = None
         return ciphertext
     
@@ -202,7 +201,7 @@
                     decrypted_plaintext = f.read()
                 proc.wait()
             except IOError as e:
-                raise PGPError(e)
+                raise CryptoError(e)
         self.gnupg.passphrase = None
         return decrypted_plaintext
 
@@ -378,7 +377,7 @@
                                 % self.name))
         return ret
 
-def timedelta_to_milliseconds(td):
+def _timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta() to milliseconds"
     return ((td.days * 24 * 60 * 60 * 1000)
             + (td.seconds * 1000)
@@ -388,7 +387,7 @@
     """A representation of a client host served by this server.
     
     Attributes:
-    approved:   bool(); 'None' if not yet approved/disapproved
+    _approved:   bool(); 'None' if not yet approved/disapproved
     approval_delay: datetime.timedelta(); Time to wait for approval
     approval_duration: datetime.timedelta(); Duration of one approval
     checker:    subprocess.Popen(); a running checker process used
@@ -416,7 +415,7 @@
     last_checker_status: integer between 0 and 255 reflecting exit
                          status of last checker. -1 reflects crashed
                          checker, or None.
-    last_enabled: datetime.datetime(); (UTC) or None
+    last_enabled: datetime.datetime(); (UTC)
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
     secret:     bytestring; sent verbatim (over TLS) to client
@@ -435,18 +434,18 @@
     
     def timeout_milliseconds(self):
         "Return the 'timeout' attribute in milliseconds"
-        return timedelta_to_milliseconds(self.timeout)
+        return _timedelta_to_milliseconds(self.timeout)
     
     def extended_timeout_milliseconds(self):
         "Return the 'extended_timeout' attribute in milliseconds"
-        return timedelta_to_milliseconds(self.extended_timeout)
+        return _timedelta_to_milliseconds(self.extended_timeout)
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
-        return timedelta_to_milliseconds(self.interval)
+        return _timedelta_to_milliseconds(self.interval)
     
     def approval_delay_milliseconds(self):
-        return timedelta_to_milliseconds(self.approval_delay)
+        return _timedelta_to_milliseconds(self.approval_delay)
     
     def __init__(self, name = None, config=None):
         """Note: the 'checker' key in 'config' sets the
@@ -474,12 +473,9 @@
                             % self.name)
         self.host = config.get("host", "")
         self.created = datetime.datetime.utcnow()
-        self.enabled = config.get("enabled", True)
+        self.enabled = True
         self.last_approval_request = None
-        if self.enabled:
-            self.last_enabled = datetime.datetime.utcnow()
-        else:
-            self.last_enabled = None
+        self.last_enabled = datetime.datetime.utcnow()
         self.last_checked_ok = None
         self.last_checker_status = None
         self.timeout = string_to_delta(config["timeout"])
@@ -489,14 +485,11 @@
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
-        if self.enabled:
-            self.expires = datetime.datetime.utcnow() + self.timeout
-        else:
-            self.expires = None
+        self.expires = datetime.datetime.utcnow() + self.timeout
         self.checker_callback_tag = None
         self.checker_command = config["checker"]
         self.current_checker_command = None
-        self.approved = None
+        self._approved = None
         self.approved_by_default = config.get("approved_by_default",
                                               True)
         self.approvals_pending = 0
@@ -576,7 +569,7 @@
         self.checker_callback_tag = None
         self.checker = None
         if os.WIFEXITED(condition):
-            self.last_checker_status = os.WEXITSTATUS(condition)
+            self.last_checker_status =  os.WEXITSTATUS(condition)
             if self.last_checker_status == 0:
                 logger.info("Checker for %(name)s succeeded",
                             vars(self))
@@ -602,7 +595,7 @@
             gobject.source_remove(self.disable_initiator_tag)
         if getattr(self, "enabled", False):
             self.disable_initiator_tag = (gobject.timeout_add
-                                          (timedelta_to_milliseconds
+                                          (_timedelta_to_milliseconds
                                            (timeout), self.disable))
             self.expires = datetime.datetime.utcnow() + timeout
     
@@ -1072,21 +1065,21 @@
     approval_delay = notifychangeproperty(dbus.UInt16,
                                           "ApprovalDelay",
                                           type_func =
-                                          timedelta_to_milliseconds)
+                                          _timedelta_to_milliseconds)
     approval_duration = notifychangeproperty(
         dbus.UInt16, "ApprovalDuration",
-        type_func = timedelta_to_milliseconds)
+        type_func = _timedelta_to_milliseconds)
     host = notifychangeproperty(dbus.String, "Host")
     timeout = notifychangeproperty(dbus.UInt16, "Timeout",
                                    type_func =
-                                   timedelta_to_milliseconds)
+                                   _timedelta_to_milliseconds)
     extended_timeout = notifychangeproperty(
         dbus.UInt16, "ExtendedTimeout",
-        type_func = timedelta_to_milliseconds)
+        type_func = _timedelta_to_milliseconds)
     interval = notifychangeproperty(dbus.UInt16,
                                     "Interval",
                                     type_func =
-                                    timedelta_to_milliseconds)
+                                    _timedelta_to_milliseconds)
     checker_command = notifychangeproperty(dbus.String, "Checker")
     
     del notifychangeproperty
@@ -1134,13 +1127,13 @@
         return r
     
     def _reset_approved(self):
-        self.approved = None
+        self._approved = None
         return False
     
     def approve(self, value=True):
         self.send_changedstate()
-        self.approved = value
-        gobject.timeout_add(timedelta_to_milliseconds
+        self._approved = value
+        gobject.timeout_add(_timedelta_to_milliseconds
                             (self.approval_duration),
                             self._reset_approved)
     
@@ -1260,7 +1253,7 @@
                            access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(timedelta_to_milliseconds(
+            return dbus.UInt64(_timedelta_to_milliseconds(
                     self.approval_duration))
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
     
@@ -1280,12 +1273,12 @@
     def Host_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.host)
-        self.host = unicode(value)
+        self.host = value
     
     # Created - property
     @dbus_service_property(_interface, signature="s", access="read")
     def Created_dbus_property(self):
-        return datetime_to_dbus(self.created)
+        return dbus.String(datetime_to_dbus(self.created))
     
     # LastEnabled - property
     @dbus_service_property(_interface, signature="s", access="read")
@@ -1335,11 +1328,11 @@
         gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = None
         self.expires = None
-        time_to_die = timedelta_to_milliseconds((self
-                                                 .last_checked_ok
-                                                 + self.timeout)
-                                                - datetime.datetime
-                                                .utcnow())
+        time_to_die = _timedelta_to_milliseconds((self
+                                                  .last_checked_ok
+                                                  + self.timeout)
+                                                 - datetime.datetime
+                                                 .utcnow())
         if time_to_die <= 0:
             # The timeout has passed
             self.disable()
@@ -1367,12 +1360,11 @@
         self.interval = datetime.timedelta(0, 0, 0, value)
         if getattr(self, "checker_initiator_tag", None) is None:
             return
-        if self.enabled:
-            # Reschedule checker run
-            gobject.source_remove(self.checker_initiator_tag)
-            self.checker_initiator_tag = (gobject.timeout_add
-                                          (value, self.start_checker))
-            self.start_checker()    # Start one now, too
+        # Reschedule checker run
+        gobject.source_remove(self.checker_initiator_tag)
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (value, self.start_checker))
+        self.start_checker()    # Start one now, too
     
     # Checker - property
     @dbus_service_property(_interface, signature="s",
@@ -1380,7 +1372,7 @@
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.checker_command)
-        self.checker_command = unicode(value)
+        self.checker_command = value
     
     # CheckerRunning - property
     @dbus_service_property(_interface, signature="b",
@@ -1415,7 +1407,7 @@
             raise KeyError()
     
     def __getattribute__(self, name):
-        if name == '_pipe':
+        if(name == '_pipe'):
             return super(ProxyClient, self).__getattribute__(name)
         self._pipe.send(('getattr', name))
         data = self._pipe.recv()
@@ -1428,7 +1420,7 @@
             return func
     
     def __setattr__(self, name, value):
-        if name == '_pipe':
+        if(name == '_pipe'):
             return super(ProxyClient, self).__setattr__(name, value)
         self._pipe.send(('setattr', name, value))
 
@@ -1503,6 +1495,9 @@
                     logger.warning("Bad certificate: %s", error)
                     return
                 logger.debug("Fingerprint: %s", fpr)
+                if self.server.use_dbus:
+                    # Emit D-Bus signal
+                    client.NewRequest(str(self.client_address))
                 
                 try:
                     client = ProxyClient(child_pipe, fpr,
@@ -1510,10 +1505,6 @@
                 except KeyError:
                     return
                 
-                if self.server.use_dbus:
-                    # Emit D-Bus signal
-                    client.NewRequest(str(self.client_address))
-                
                 if client.approval_delay:
                     delay = client.approval_delay
                     client.approvals_pending += 1
@@ -1528,10 +1519,10 @@
                             client.Rejected("Disabled")
                         return
                     
-                    if client.approved or not client.approval_delay:
+                    if client._approved or not client.approval_delay:
                         #We are approved or approval is disabled
                         break
-                    elif client.approved is None:
+                    elif client._approved is None:
                         logger.info("Client %s needs approval",
                                     client.name)
                         if self.server.use_dbus:
@@ -1551,7 +1542,7 @@
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
                     (client.changedstate.wait
-                     (float(client.timedelta_to_milliseconds(delay)
+                     (float(client._timedelta_to_milliseconds(delay)
                             / 1000)))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
@@ -1981,9 +1972,7 @@
                         dest="use_ipv6", help="Do not use IPv6")
     parser.add_argument("--no-restore", action="store_false",
                         dest="restore", help="Do not restore stored"
-                        " state")
-    parser.add_argument("--statedir", metavar="DIR",
-                        help="Directory to save/restore state in")
+                        " state", default=True)
     
     options = parser.parse_args()
     
@@ -2003,8 +1992,6 @@
                         "use_dbus": "True",
                         "use_ipv6": "True",
                         "debuglevel": "",
-                        "restore": "True",
-                        "statedir": "/var/lib/mandos"
                         }
     
     # Parse config file for server-global settings
@@ -2027,8 +2014,7 @@
     # options, if set.
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
-                   "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir"):
+                   "use_dbus", "use_ipv6", "debuglevel", "restore"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2046,8 +2032,6 @@
     debuglevel = server_settings["debuglevel"]
     use_dbus = server_settings["use_dbus"]
     use_ipv6 = server_settings["use_ipv6"]
-    stored_state_path = os.path.join(server_settings["statedir"],
-                                     stored_state_file)
     
     if debug:
         initlogger(logging.DEBUG)
@@ -2186,9 +2170,6 @@
         "approved_by_default":
             lambda section:
             client_config.getboolean(section, "approved_by_default"),
-        "enabled":
-            lambda section:
-            client_config.getboolean(section, "enabled"),
         }
     # Construct a new dict of client settings of this form:
     # { client_name: {setting_name: value, ...}, ...}
@@ -2219,7 +2200,7 @@
             if e.errno != errno.ENOENT:
                 raise
     
-    with PGPEngine() as pgp:
+    with Crypto() as crypt:
         for client in clients_data:
             client_name = client["name"]
             
@@ -2244,10 +2225,10 @@
             # enabled if its last checker was sucessful.  Clients
             # whose checker failed before we stored its state is
             # assumed to have failed all checkers during downtime.
-            if client["enabled"]:
-                if client["expires"] <= (datetime.datetime
-                                         .utcnow()):
-                    # Client has expired
+            if client["enabled"] and client["last_checked_ok"]:
+                if ((datetime.datetime.utcnow()
+                     - client["last_checked_ok"])
+                    > client["interval"]):
                     if client["last_checker_status"] != 0:
                         client["enabled"] = False
                     else:
@@ -2285,14 +2266,12 @@
             
             try:
                 tcp_server.clients[client_name].secret = (
-                    pgp.decrypt(tcp_server.clients[client_name]
-                                .encrypted_secret,
-                                client_settings[client_name]
-                                ["secret"]))
-            except PGPError:
+                    crypt.decrypt(tcp_server.clients[client_name]
+                                  .encrypted_secret,
+                                  client_settings[client_name]
+                                  ["secret"]))
+            except CryptoError:
                 # If decryption fails, we use secret from new settings
-                logger.debug("Failed to decrypt {0} old secret"
-                             .format(client_name))
                 tcp_server.clients[client_name].secret = (
                     client_settings[client_name]["secret"])
     
@@ -2398,11 +2377,11 @@
         # based on what config file has. If config file is
         # removed/edited, old secret will thus be unrecovable.
         clients = []
-        with PGPEngine() as pgp:
+        with Crypto() as crypt:
             for client in tcp_server.clients.itervalues():
                 key = client_settings[client.name]["secret"]
-                client.encrypted_secret = pgp.encrypt(client.secret,
-                                                      key)
+                client.encrypted_secret = crypt.encrypt(client.secret,
+                                                        key)
                 client_dict = {}
                 
                 # A list of attributes that will not be stored when

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2011-11-26 23:08:17 +0000
+++ mandos-clients.conf.xml	2011-10-10 20:29:58 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2011-11-26">
+<!ENTITY TIMESTAMP "2011-10-10">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -344,20 +344,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>enabled<literal> = </literal>{ <literal
-	>1</literal> | <literal>yes</literal> |	<literal>true</literal
-	> | <literal >on</literal> | <literal>0</literal> | <literal
-	>no</literal> | <literal>false</literal> | <literal
-	>off</literal> }</option></term>
-	<listitem>
-	  <para>
-	    Whether this client should be enabled by default.  The
-	    default is <quote>true</quote>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2011-11-26 22:22:20 +0000
+++ mandos-options.xml	2011-11-09 17:16:03 +0000
@@ -85,16 +85,10 @@
     to the server if this option is turned off.  <emphasis>Only
     advanced users should consider changing this option</emphasis>.
   </para>
-  
+
   <para id="restore">
     This option controls whether the server will restore any state from
     last time it ran. Default is to try restore last state.
   </para>
   
-  <para id="statedir">
-    Directory to save (and restore) state in.  Default is
-    <quote><filename
-    class="directory">/var/lib/mandos</filename></quote>.
-  </para>
-  
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2011-11-26 22:22:20 +0000
+++ mandos.conf	2009-02-13 05:38:21 +0000
@@ -4,27 +4,33 @@
 # These are the default values for the server, uncomment and change
 # them if needed.
 
+
 # If "interface" is set, the server will only listen to a specific
 # network interface.
 ;interface = 
 
+
 # If "address" is set, the server will only listen to a specific
 # address.  This must currently be an IPv6 address; an IPv4 address
 # can be specified using the "::FFFF:192.0.2.3" syntax.  Also, if this
 # is a link-local address, an interface should be set above.
 ;address =
 
+
 # If "port" is set, the server to bind to that port. By default, the
 # server will listen to an arbitrary port.
 ;port = 
 
+
 # If "debug" is true, the server will run in the foreground and print
 # a lot of debugging information.
 ;debug = False
 
+
 # GnuTLS priority for the TLS handshake.  See gnutls_priority_init(3).
 ;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
 
+
 # Zeroconf service name.  You need to change this if you for some
 # reason want to run more than one server on the same *host*.
 # If there are name collisions on the same *network*, the server will
@@ -36,9 +42,3 @@
 
 # Whether to use IPv6.  (Changing this is NOT recommended.)
 ;use_ipv6 = True
-
-# Whether to restore saved state on startup
-;restore = True
-
-# The directory where state is saved
-;statedir = /var/lib/mandos

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2011-11-26 22:22:20 +0000
+++ mandos.conf.xml	2011-10-05 16:00:56 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2011-11-26">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -154,25 +154,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>restore<literal> = </literal>{ <literal
-	  >1</literal> | <literal>yes</literal> | <literal
-	  >true</literal> | <literal>on</literal> | <literal
-	  >0</literal> | <literal>no</literal> | <literal
-	  >false</literal> | <literal>off</literal> }</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="restore"/>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>statedir<literal> = </literal><replaceable
-	>DIRECTORY</replaceable></option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   
@@ -217,8 +198,6 @@
 servicename = Daena
 use_dbus = False
 use_ipv6 = True
-restore = True
-statedir = /var/lib/mandos
       </programlisting>
     </informalexample>
   </refsect1>

=== modified file 'mandos.xml'
--- mandos.xml	2011-11-26 22:22:20 +0000
+++ mandos.xml	2011-11-09 17:16:03 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2011-11-26">
+<!ENTITY TIMESTAMP "2011-10-22">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -96,9 +96,6 @@
       <arg><option>--no-ipv6</option></arg>
       <sbr/>
       <arg><option>--no-restore</option></arg>
-      <sbr/>
-      <arg><option>--statedir
-      <replaceable>DIRECTORY</replaceable></option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -287,14 +284,6 @@
 	  <xi:include href="mandos-options.xml" xpointer="restore"/>
 	</listitem>
       </varlistentry>
-      
-      <varlistentry>
-	<term><option>--statedir
-	<replaceable>DIRECTORY</replaceable></option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -489,17 +478,6 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename
-	class="directory">/var/lib/mandos</filename></term>
-	<listitem>
-	  <para>
-	    Directory where persistent state will be saved.  Change
-	    this with the <option>--statedir</option> option.  See
-	    also the <option>--no-restore</option> option.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
 	<term><filename>/dev/log</filename></term>
 	<listitem>
 	  <para>
@@ -529,6 +507,11 @@
       backtrace.  This could be considered a feature.
     </para>
     <para>
+      Currently, if a client is disabled due to having timed out, the
+      server does not record this fact onto permanent storage.  This
+      has some security implications, see <xref linkend="clients"/>.
+    </para>
+    <para>
       There is no fine-grained control over logging and debug output.
     </para>
     <para>
@@ -553,9 +536,9 @@
     <informalexample>
       <para>
 	Run the server in debug mode, read configuration files from
-	the <filename class="directory">~/mandos</filename> directory,
-	and use the Zeroconf service name <quote>Test</quote> to not
-	collide with any other official Mandos server on this host:
+	the <filename>~/mandos</filename> directory, and use the
+	Zeroconf service name <quote>Test</quote> to not collide with
+	any other official Mandos server on this host:
       </para>
       <para>
 
@@ -610,6 +593,21 @@
 	compromised if they are gone for too long.
       </para>
       <para>
+	If a client is compromised, its downtime should be duly noted
+	by the server which would therefore disable the client.  But
+	if the server was ever restarted, it would re-read its client
+	list from its configuration file and again regard all clients
+	therein as enabled, and hence eligible to receive their
+	passwords.  Therefore, be careful when restarting servers if
+	it is suspected that a client has, in fact, been compromised
+	by parties who may now be running a fake Mandos client with
+	the keys from the non-encrypted initial <acronym>RAM</acronym>
+	image of the client host.  What should be done in that case
+	(if restarting the server program really is necessary) is to
+	stop the server program, edit the configuration file to omit
+	any suspect clients, and restart the server program.
+      </para>
+      <para>
 	For more details on client-side security, see
 	<citerefentry><refentrytitle>mandos-client</refentrytitle>
 	<manvolnum>8mandos</manvolnum></citerefentry>.

